Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## avrora.core.isdl.ast
Class VarBitAssignStmt

    java.lang.Object
      avrora.core.isdl.ast.Stmt
          avrora.core.isdl.ast.AssignStmt
              avrora.core.isdl.ast.VarBitAssignStmt

public class VarBitAssignStmt
extends AssignStmt

The `VarBitAssignStmt` class represents an assignment to a single bit within a local or global variable.

Field Summary
`Expr` | `bit` The `bit` field stores a reference to the expression that represents the expr of the bit to assign to.
`Token` | `variable` The `variable` field stores a reference to the token that represents the name of the variable being assigned to.

Fields inherited from class avrora.core.isdl.ast.AssignStmt
`expr`

Constructor Summary
`VarBitAssignStmt(java.lang.String m, Expr b, Expr e)` The constructor for the `VarAssignStmt` class simply initializes the internal references to the internal members of this assignment.
`VarBitAssignStmt(Token m, Expr b, Expr e)` The constructor for the `VarAssignStmt` class simply initializes the internal references to the internal members of this assignment.

Method Summary
`Stmt` | `accept(StmtRebuilder r, java.lang.Object env)` The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine.
`void` | `accept(StmtVisitor v)` The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine.
`java.lang.String` | `toString()` The `toString()` method recursively converts this statement to a string.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### variable

    public final Token variable

  The `variable` field stores a reference to the token that represents the name of the variable being assigned to.

### bit

    public final Expr bit

  The `bit` field stores a reference to the expression that represents the expr of the bit to assign to.

Constructor Detail

### VarBitAssignStmt

    public VarBitAssignStmt(Token m,
                            Expr b,
                            Expr e)

  The constructor for the `VarAssignStmt` class simply initializes the internal references to the internal members of this assignment.

Parameters:
  `m` - the string name of the variable as a token
  `b` - an expression representing the expr of the bit
  `e` - an expression representing the right hand side of the assignment

### VarBitAssignStmt

    public VarBitAssignStmt(java.lang.String m,
                            Expr b,
                            Expr e)

  The constructor for the `VarAssignStmt` class simply initializes the internal references to the internal members of this assignment.

Parameters:
  `m` - the string name of the variable as a token
  `b` - an expression representing the expr of the bit
  `e` - an expression representing the right hand side of the assignment

Method Detail

### accept

    public void accept(StmtVisitor v)

  The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine.

  Specified by:
    `accept` in class `Stmt`
  Parameters:
    `v` - the visitor to accept

### toString

    public java.lang.String toString()

  The `toString()` method recursively converts this statement to a string.

  Returns:
    a string representation of this statement

### accept

    public Stmt accept(StmtRebuilder r,
                       java.lang.Object env)

  The `accept()` method implements one half of the visitor pattern for visiting the abstract syntax trees representing the code of a particular instruction or subroutine. The `StmtRebuilder` interface allows visitors to rearrange and rebuild the statements.

  Specified by:
    `accept` in class `Stmt`
  Parameters:
    `r` - the visitor to accept
  Returns:
    the result of calling the appropriate `visit()` of the rebuilder passed

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD